# -*- coding: utf-8 -*-
"""Lecture 13 - KNN Exercise.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1p1MU4vjnISPTDucrypoU1A_NU1n4P5Mt

# ITS307 Data Analytics                                                   : Spring Semester 2022
# Lecture 12 - Exercise
# K Nearest Neighbours

![image.png](attachment:image.png)

# Import Libraries
"""

import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import seaborn as sns
from sklearn import datasets

"""# Part A - KNN for Classification

# 1. Data Manipulation with pandas
"""

iris = datasets.load_iris()
iris.keys()

"""# 2. EDA


1. Create correlation matrix and plot it using heatmap
2. Use petel length and petel witdth to check distribution of your data (Scatter plot)

Note: Use seaborn
"""





"""# 3. Split data into traning and test set

Note: Make sure that your train and test split will have equal number of data from each class
"""

from sklearn.model_selection import train_test_split
x_train, x_test, y_train, y_test = train_test_split(iris.data,iris.target,test_size=0.2,random_state=5,shuffle=True, stratify = iris.target)
y_test

"""# 4. Training Model"""

from sklearn.neighbors import KNeighborsClassifier
knn = KNeighborsClassifier(n_neighbors=5)
knn.fit(x_train,y_train)

"""# 5. Model Evaluation

1. Check train and test score
2. Display number of truely predicted sample in each class (Confusion matrix)
"""

knn.score(x_train,y_train)

knn.score(x_test,y_test)

y_pred = knn.predict(x_test)
y_pred

y_test

from sklearn.metrics import confusion_matrix
matrix = confusion_matrix(y_test,y_pred)
matrix

sns.heatmap(data=matrix,annot=True)
plt.xlabel("Predicted")
plt.ylabel("True value")

knn.predict_proba(x_test)

"""# 6. Chosing best k

1. Plot train and test score for k values ranging from 1 to 50
"""

trainscore = []
testscore = []
for k in range(1,50):
    knn = KNeighborsClassifier(n_neighbors=k)
    knn.fit(x_train, y_train)
    knn.score(x_train,y_train)
    knn.score(x_test,y_test)
    trainscore.append(knn.score(x_train, y_train))
    testscore.append(knn.score(x_test, y_test))

x=np.arange(1,50)

plt.plot(x, trainscore)
plt.plot(x, testscore)
plt.show()

"""# Part B - KNN for Regression

Use boston data to implement KNN in Regression.

Note: Experiment affect of feature scaling.
"""

boston = datasets.load_boston()
boston.keys()

xtrain, xtest, ytrain,ytest = train_test_split(boston.data, boston.target,test_size=0.2,random_state=5)
xtrain.shape

xtest.shape

"""here test shape 102,13 which mean 1 to 102 row and 1 to 13 column """

from sklearn.linear_model import LinearRegression
from sklearn.metrics import mean_squared_error
linearmodel = LinearRegression() #creating a object for linear regression based on target (ytest) which is in numeric
linearmodel.fit(xtrain,ytrain) #for output (model has already learn and it letting to predict new y)
y_pred = linearmodel.predict(xtest) #calling linaer regression 
MSE =  mean_squared_error(ytest,y_pred) #to find the accuracy of the mean squared (actual y 102 feature is there in ytest) sum of those error is MSE
MSE

linearmodel.score(xtest,ytest)

from sklearn.neighbors import KNeighborsRegressor
knnr = KNeighborsRegressor(n_neighbors=6)
knnr.fit(xtrain,ytrain)
y_pred = knnr.predict(xtest) 
MSE =  mean_squared_error(ytest,y_pred)
MSE

#scaling the data
from sklearn.preprocessing import StandardScaler
sc = StandardScaler()
x_scaled = sc.fit_transform(boston.data)

x_train, x_test, y_train,y_test = train_test_split(x_scaled, boston.target,test_size=0.2,random_state=5)

lr = LinearRegression()
lr.fit(x_train,y_train)
y_pred = lr.predict(x_test)
MSE = mean_squared_error(y_test,y_pred)
MSE

knnrg = KNeighborsRegressor(n_neighbors = 6)
knnrg.fit(x_train,y_train)
y_pred = knnrg.predict(x_test)
MSE = mean_squared_error(y_test,y_pred)
MSE

MSEtr = []
MSEte = []
for k in range(1,50):
  knnrg =  KNeighborsRegressor(n_neighbors = k)
  knnrg.fit(x_train,y_train)
  y_pred_train = knnrg.predict(x_train)
  y_pred_test = knnrg.predict(x_test)
  MSE1 = mean_squared_error(y_train,y_pred_train)
  MSEtr.append(MSE1)
  MSE2 = mean_squared_error(y_test,y_pred_test)
  MSEte.append(MSE2)

plt.plot(np.arange(1,50),MSEtr)
plt.plot(np.arange(1,50),MSEte)
plt.show()

"""# Conclusion

Regularization improves the accuracy of the model which will helps to improve overfitting and unfitting model and select K best improves the accuracy of the model by reducing the number of training data that can visulizes how our training datas
"""